# Set the all_in_one parameter to:
#   True - to do all the work in a single test function call
#   False - to split the work over multiple test function calls
all_in_one = True
all_in_one = False

#   If the test seems to run too slow or too fast on your computer, change the
# total number of run assertions by adjusting the work_count parameter.
#
# In my test run I got the following times with work_count == 1000:
#   all_in_one = True ... 0.03 seconds.
#   all_in_one = False ... 5.44 seconds.
work_count = 1000


def pytest_generate_tests(metafunc):
    if metafunc.function.__name__ == "test":
        external = internal = 1
        if all_in_one:
            internal = work_count
        else:
            external = work_count
        for i in range(0, external):
            metafunc.addcall(funcargs=dict(count=internal))


def test(count):
    for i in range(0, count):
        assert 0 == 0
