import pytest


class Person:
    population = 0

    def __init__(self, name):
        self.name = name
        print("\nNew Object for %s : %s" % (name, self))
        Person.population += 1

    def __del__(self):
        print 'Object for %s is deleted.' % self.name
        Person.population -= 1

    def getName(self):
        return self.name

    def sayHello(self):
        return 'Hello! my name is %s.' % self.name

    def count(self):
        return Person.population


def pytest_generate_tests(metafunc):
    if 'human' in metafunc.fixturenames:
        nameList = ["John", "Doe"]
        metafunc.parametrize("human", nameList, indirect=True, scope='class')


@pytest.fixture
def human(request):
    name = request.param
    human = Person(name)

    def finalizer():
        print("\nFinalizer called for %s" % human)
    request.addfinalizer(finalizer)
    return human


class TestGreetings:
    def test_hello(self, human):
        assert human.sayHello()
    #
    #def test_bye(self):
    #    pass


class TestMetrics:
    def test_name_length(self, human):
        assert len(human.getName()) > 0

    def test_population_count(self, human):
        assert human.count() >= 0
