import os
from oslo.config import cfg

CONF = cfg.CONF

FILE_OPTIONS = {
    '': [ cfg.StrOpt("baseplanet", default="Secret", help=("The outpost, i.e. Yavin IV")),
          cfg.StrOpt("basename", default=None, help=("Basenames, like Alpha Base"))
    ],
    'enemy' : [ cfg.StrOpt("Commander", default="No Data", help=("Grand Moff Tarkin")),
          cfg.StrOpt("WhoElse", default="No Data", help=("They come in pairs, just like the Sith."))
    ]
}

def configure(conf=None):
    if conf is None:
        conf = CONF

    for section in FILE_OPTIONS:
        for option in FILE_OPTIONS[section]:
            if section:
                conf.register_opt(option, group=section)
            else:
                conf.register_opt(option)

    try:
        _conffile = os.path.abspath("breakit.conf")
        CONF(default_config_files=[_conffile])
        # pass
    except cfg.ConfigFilesNotFoundError, e:
        raise cfg.ConfigFilesNotFoundError(e.config_files)

configure()

class BringItOn(object):
    def whoelse(self):
        # print(CONF.enemy.WhoElse)
        return CONF.enemy.WhoElse