import pytest

values = [ 'val2', 'val1' ]

def pytest_generate_tests(metafunc):
    if not 'fixture' in metafunc.fixturenames:
        return
    
    if hasattr(metafunc.function, 'requires_val1'):
        vals = [ x for x in values if x == 'val1' ]
    else:
        vals = values
    metafunc.parametrize("fixture", vals, ids=[ str(v) for v in vals ],
                         scope='module', indirect=True)

@pytest.fixture()
def fixture(request):
    return request.param

def test_one(fixture):
    assert fixture in ('val1', 'val2')

def test_two(fixture):
    assert fixture == 'val1'
test_two.requires_val1 = True


