import tempfile, os, sys, shutil, atexit, time

import importlib
if hasattr(importlib, 'reload'):
    reload = importlib.reload

# make temporary directory to write module code
path = tempfile.mkdtemp()
sys.path.insert(0, path)
def cleanup():
    shutil.rmtree(path)
atexit.register(cleanup)


code = """
def fn():
    return {version}
"""


def test_reload():
    # write a module
    mod = os.path.join(path, 'reload_test.py')
    open(mod, 'w').write(code.format(version=1))
    
    # import the new module and test it
    import reload_test
    #assert reload_test.fn() == 1, "failed"
    if reload_test.fn() != 1:
        raise ValueError()
    
    # Sleep to ensure the mtimes are different and .pyc is regenerated
    time.sleep(1.0)

    # write a new version of the module
    open(mod, 'w').write(code.format(version=2))

    # reload and retest
    reload(reload_test)
    #assert reload_test.fn() == 2, "failed"
    if reload_test.fn() != 2:
        raise ValueError()


if __name__ == '__main__':
    test_reload()
    print("Test passed.")
