import sys
import pytest

def test_ZeroDivisionError_try():
    try:
        1 / 0
    except ZeroDivisionError as e:
        assert isinstance(e, ZeroDivisionError)

def test_KeyError_try():
    try:
        x = {}
        x["breakme"]
    except KeyError as e:
        assert isinstance(e, KeyError)

def test_IOError_try():
    try:
        open("nofile")
    except IOError as e:
        assert isinstance(e, IOError)


def test_ZeroDivisionError_pytest():
    with pytest.raises(ZeroDivisionError) as e:
        1 / 0

    assert isinstance(e.value, ZeroDivisionError)

def test_KeyError_pytest():
    with pytest.raises(KeyError) as e:
        x = {}
        x["breakme"]

    assert isinstance(e.value, KeyError)

def test_IOError_pytest():
    with pytest.raises(IOError) as e:
        open("nofile")

    assert isinstance(e.value, IOError)
