def pytest_addoption(parser):
    group = parser.getgroup('sample')
    group._addoption('--with-config', 
                     dest='config_file', 
                     metavar='path', 
                     default='./test.py',
                     action='store', 
                     type='string', 
                     help='configuration file for sample tests')


def pytest_configure(config):
    if config.getvalue('config_file'):
        config.pluginmanager.register(SamplePlugin(config), '_sample')


class SamplePlugin(object):
    
    def __init__(self, config):
        self.config = config
    
    def pytest_namespace(self):
        return {
            'sample_variable': 'testing'
        }
