import py.test
from collections import OrderedDict, defaultdict
from .collections import *

class FrozenDict(dict):
    pass

class FrozenOrderedDict(dict):
    pass

def _check_dict_is_immutable( d ):
    print( d.__class__ )
    help( d )
    with py.test.raises(AttributeError):
        d[1234] = 156
    key = list(d)[0]
    with py.test.raises(AttributeError):
        del d[key]
    with py.test.raises(AttributeError):
        d.clear()
    with py.test.raises(AttributeError):
        d.pop()
    with py.test.raises(AttributeError):
        d.setdefault()
    with py.test.raises(AttributeError):
        d.update()

def _test_freeze_dict_class( actual_dict, sample_dict ):
    assert actual_dict == sample_dict
    assert len(actual_dict) == len(sample_dict)
    assert sorted( actual_dict.keys() ) == sorted( sample_dict.keys() )
    assert sorted( actual_dict.values() ) == sorted( sample_dict.values() )
    assert sorted( actual_dict.items() ) == sorted( sample_dict.items() )
    assert sorted( actual_dict ) == sorted( sample_dict )
    for key in sample_dict:
        assert key in actual_dict
    assert 'BADKEY' not in actual_dict
    assert actual_dict.get('BADKEY') is None
    assert actual_dict.get('BADKEY', 'VAL') == 'VAL'
    _check_dict_is_immutable( actual_dict )
    

def test_freeze_dict():
    expected1 = dict(a=1, b=2, c=3)
    actual1 = FrozenDict( a=1, b=2, c=3 )
    _test_freeze_dict_class( actual1, expected1 )
##    actual1 = FrozenDict( s1 )
##    _test_freeze_dict_class( actual1, expected1 )
##
##def test_freeze_defaultdict():
##    d = defaultdict( 0 )
##    d['a'] += 1
##    d['b'] += 2
##    d['c'] += 3
##    _test_freeze_dict_class( d )
##
##def test_freeze_OrderedDict():
##    _test_freeze_dict_class( FrozenOrderedDict, dict(a=1, b=2, c=3) )
