import unittest

from tennis import tennis_score

class TennisTest(unittest.TestCase):
    
    def assert_tennis_score(self, expected_output, player1_score, player2_score):
        self.assertEqual(expected_output, tennis_score(player1_score, player2_score))

test_case_data = \
{ 
  "even_scores":                      [("Love-All", 0, 0), 
                                       ("Fifteen-All", 1, 1),
                                       ("Thirty-All", 2, 2),
                                      ],
  "early_games_with_uneven_scores":   [("Love-Fifteen", 0, 1),
                                       ("Fifteen-Love", 1, 0),
                                       ("Thirty-Fifteen", 2, 1),
                                       ("Forty-Thirty", 3, 2),
                                      ],
  # "endgame_with_uneven_scores":       [("Advantage Player 1", 4, 3),
  #                                      ("Advantage Player 2", 5, 6),
  #                                      ("Advantage Player 1", 23, 22), 
  #                                     ],
  # "endgame_with_even_scores":         [("Deuce", 3, 3),
  #                                      ("Deuce", 4, 4),
  #                                      ("Deuce", 14, 14),  
  #                                     ],
  # "there_is_a_winner":                [("Win for Player 1", 4, 0),
  #                                      ("Win for Player 2", 1, 4),
  #                                      ("Win for Player 1", 6, 4),
  #                                     ],
}

def my_test_template(*args):
    def foo(self):
        self.assert_tennis_score(*args)
    return foo

for behaviour, test_cases in test_case_data.items():
    for test_case_data in test_cases:
        expected_output, player1_score, player2_score = test_case_data
        test_name = "test_{0}_{1}_{2}".format(behaviour, player1_score, player2_score)
        test_case = my_test_template(*test_case_data)
        setattr(TennisTest, test_name, test_case)
        