import pytest

from phonebook import Phonebook

# this one works
# @pytest.fixture
# def phonebook():
#     return Phonebook()

# this one works
# @pytest.fixture 
# def phonebook(request):
#     phonebook = Phonebook()
#     def cleanup_phonebook():
#         phonebook.clear()
#     request.addfinalizer(cleanup_phonebook)
#     return phonebook
    
# this one doesn't work
@pytest.fixture 
def phonebook():
    phonebook = Phonebook()
    yield phonebook
    phonebook.clear()

def test_lookup_entry(phonebook):
    phonebook.add("Bob", "123")
    assert "123" == phonebook.lookup("Bob")

def test_missing_entry_raises_KeyError(phonebook):
    with pytest.raises(KeyError):
        phonebook.lookup("missing")

def test_empty_phonebook_is_consistent(phonebook):
    assert phonebook.is_consistent()