import sys
import pytest

@pytest.fixture(autouse=True)
def save_capfd_fixture(request, capfd):
    request.capfd = capfd

def pytest_runtest_call(__multicall__, item):
     cap = item._request.capfd
     report = __multicall__.execute()

     # Peek at captured output
     (stdout, stderr) = cap.readouterr()
     sys.stdout.write(stdout)
     sys.stderr.write(stderr)

     # Check for problems
     if ('exception' in stderr.lower()
         or 'exception' in stdout.lower()):
         raise AssertionError('Suspicious output to stderr')

     return report

